/*
 * Decompiled with CFR 0.152.
 */
package fire.pb.scene.sPos;

public abstract class BasicPos {
    private int x;
    private int y;
    private int z;
    public static final int DIR_UNKNOW = -1;
    public static final int DIR_SELF = 0;
    public static final int DIR_UP = 1;
    public static final int DIR_RIGHTUP = 2;
    public static final int DIR_RIGHT = 3;
    public static final int DIR_RIGHTDOWN = 4;
    public static final int DIR_DOWN = 5;
    public static final int DIR_LEFTDOWN = 6;
    public static final int DIR_LEFT = 7;
    public static final int DIR_LEFTUP = 8;
    public static final int DIR_NUM = 8;

    public BasicPos(int x0, int y0, int z0) {
        this.x = x0;
        this.y = y0;
        this.z = z0;
    }

    public BasicPos(int x0, int y0) {
        this.x = x0;
        this.y = y0;
        this.z = 0;
    }

    public int hashCode() {
        return (this.x << 16) + this.y;
    }

    public boolean equals(BasicPos o) {
        if (this == o) {
            return true;
        }
        if (!this.getClass().equals(o.getClass())) {
            return false;
        }
        return this.x == o.x && this.y == o.y && this.z == o.z;
    }

    public boolean isSamePos(BasicPos o) {
        return this.equals(o);
    }

    public int getX() {
        return this.x;
    }

    public int getY() {
        return this.y;
    }

    public int getZ() {
        return this.z;
    }

    public int getDistance(BasicPos o) {
        int highth;
        if (!o.getClass().equals(this.getClass())) {
            throw new IllegalArgumentException("不同的坐标类型");
        }
        int width = Math.abs(this.getX() - o.getX());
        return width > (highth = Math.abs(this.getY() - o.getY())) ? width : highth;
    }

    public int getDirectDistance(BasicPos to) {
        if (!to.getClass().equals(this.getClass())) {
            throw new IllegalArgumentException("不同的坐标类型");
        }
        int decx = this.getX() - to.getX();
        int decy = this.getY() - to.getY();
        return (int)Math.sqrt(decx * decx + decy * decy);
    }

    public String toString() {
        return "(" + this.x + "," + this.y + "," + this.z + ")";
    }

    public int where(BasicPos w) {
        if (this.x == w.x && w.y == this.y) {
            return 0;
        }
        if (this.x == w.x && w.y + 1 == this.y) {
            return 1;
        }
        if (this.x + 1 == w.x && w.y + 1 == this.y) {
            return 2;
        }
        if (this.x + 1 == w.x && w.y == this.y) {
            return 3;
        }
        if (this.x + 1 == w.x && this.y + 1 == w.y) {
            return 4;
        }
        if (this.x == w.x && this.y + 1 == w.y) {
            return 5;
        }
        if (w.x + 1 == this.x && this.y + 1 == w.y) {
            return 6;
        }
        if (w.x + 1 == this.x && w.y == this.y) {
            return 7;
        }
        if (w.x + 1 == this.x && w.y + 1 == this.y) {
            return 8;
        }
        return -1;
    }

    public boolean isAround(BasicPos o) {
        if (this.isSamePos(o)) {
            return true;
        }
        int dir = this.where(o);
        if (dir < 0) {
            return false;
        }
        return dir <= 8;
    }

    public short getWalkBlockType() {
        if (this.getZ() == 0) {
            return 1;
        }
        return 8;
    }

    public static int getReverseDir(int dir) {
        return (dir + 4) % 8;
    }

    public static void main(String[] args) {
    }
}

